﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Forms;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication2
{
    /// <summary>
    /// Interaktionslogik für Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();
        }

        private void menuExit(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        private void saveFileAs(object sender, RoutedEventArgs e)
        {
            SaveFileDialog sdlg = new SaveFileDialog();
            sdlg.DefaultExt = ".btd";
            sdlg.Filter = "Bluetype Documents (.btd)|*.btd";
            if (sdlg.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                SaveBluetypeDocumentAs(sdlg.FileName);
            }
        }

        private void SaveBluetypeDocumentAs(string fileName)
        {
            TextRange range;
            FileStream fStream;

            fStream = new FileStream(fileName, FileMode.CreateNew, FileAccess.Write);
            range = new TextRange(rtb1.Document.ContentStart, rtb1.Document.ContentEnd);
            range.Save(fStream, System.Windows.Forms.DataFormats.Text);
            fStream.Close();

        }

        private void saveFile(object sender, RoutedEventArgs e)
        {
            SaveFileDialog sdlg = new SaveFileDialog();
            sdlg.DefaultExt = ".btd";
            sdlg.Filter = "Bluetype Documents (.btd)|*.btd";
            if (sdlg.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                SaveBluetypeDocument(sdlg.FileName);
            }
        }

        private void SaveBluetypeDocument(string fileName)
        {
            TextRange range;
            FileStream fStream;

            if(File.Exists(fileName))
            {
                fStream = new FileStream(fileName, FileMode.Open, FileAccess.Write);
                range = new TextRange(rtb1.Document.ContentStart, rtb1.Document.ContentEnd);
                range.Save(fStream, System.Windows.Forms.DataFormats.Text);
                fStream.Close();
            }

        }

        private void openFile(object sender, RoutedEventArgs e)
        {
            OpenFileDialog dlg = new OpenFileDialog();
            dlg.DefaultExt = ".btd";
            dlg.Filter = "Bluetype Documents (.btd)|*.btd";
            if (dlg.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                LoadBluetypeDocument(dlg.FileName);
            }
            else
            {
                this.Focus();
            }
        }

        // Create a Delegate that matches 
        // the Signature of the ProgressBar's SetValue method
        private delegate void UpdateProgressBarDelegate(System.Windows.DependencyProperty dp, Object value);

        // Counts the lines of a File.
        private static int CountLines(string fileToCount)
        {
            int counter = 0;
            using (StreamReader countReader = new StreamReader(fileToCount))
            {
                while (countReader.ReadLine() != null)
                    counter++;
            }
            return counter;
        }

        private void LoadBluetypeDocument(string fileName)
        {
            TextRange range;
            StreamReader streamReader;
            string fileText = "";
            
            pb1.Value = 0;
            double value = 0;
            double max = 0;

            // Create a new instance of our ProgressBar Delegate that points
            // to the ProgressBar's SetValue method.
            UpdateProgressBarDelegate updatePbDelegate = new UpdateProgressBarDelegate(pb1.SetValue);

            if (File.Exists(fileName))
            {
                sbi1.Content = "Datei wird eingelesen";
                range = new TextRange(rtb1.Document.ContentStart, rtb1.Document.ContentEnd);
                streamReader = File.OpenText(fileName);

                max = CountLines(fileName);
                pb1.Minimum = 0;
                pb1.Maximum = max;
                
                while (!streamReader.EndOfStream)
                {
                    fileText += streamReader.ReadLine();
                    fileText += "\r";
                    value += 1;
                    pb1.Value = value; 
                    // Update the Value of the ProgressBar:
                    // Pass the "updatePbDelegate" delegate
                    // that points to the ProgressBar1.SetValue method
                    // Set the DispatcherPriority to "Background"
                    // Pass an Object() Array containing the property
                    // to update (ProgressBar.ValueProperty) and the new value
                    Dispatcher.Invoke(updatePbDelegate, System.Windows.Threading.DispatcherPriority.Background, new object[] { System.Windows.Controls.ProgressBar.ValueProperty, value });
                }

                sbi1.Content = "Bereit";
                pb1.Value = 0;

                range.Text = fileText;
            }
            else
            {
                this.Focus();
            }
        }

    }
}
